package cn.com.taiji.service.impl;

import cn.com.taiji.constants.EsIndexConstants;
import cn.com.taiji.entity.QueryVo;
import cn.com.taiji.entity.TianaoRadar;
import cn.com.taiji.service.TianaoService;
import cn.com.taiji.utils.DateUtils;
import com.alibaba.fastjson.JSON;
import org.elasticsearch.action.search.SearchRequest;
import org.elasticsearch.action.search.SearchResponse;
import org.elasticsearch.client.RequestOptions;
import org.elasticsearch.client.RestHighLevelClient;
import org.elasticsearch.index.query.BoolQueryBuilder;
import org.elasticsearch.index.query.QueryBuilders;
import org.elasticsearch.search.SearchHit;
import org.elasticsearch.search.builder.SearchSourceBuilder;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @author chenfangchao
 * @title: TianaoServiceImpl
 * @projectName es-track-analysis
 * @description: TODO
 * @date 2023/2/6 5:53 PM
 */
@Service
public class TianaoServiceImpl implements TianaoService {

    @Autowired
    private RestHighLevelClient restHighLevelClient;

    @Override
    public List<TianaoService> tianaRader(QueryVo query) {
        List<String> tianaoRadarIdList = new ArrayList<>();
        String time = DateUtils.format(new Date(),"yyyy-MM-dd");
        SearchRequest searchRequest = new SearchRequest(EsIndexConstants.INDEX_SEAT_TRACK_RADAR + time);
        // 构建查询条件
        BoolQueryBuilder boolQueryBuilder = QueryBuilders.boolQuery();
        SearchSourceBuilder searchSourceBuilder = new SearchSourceBuilder();
        boolQueryBuilder.filter(QueryBuilders.rangeQuery("mergeTime").gte(query.getStartTime()).lte(query.getEndTime()));
        searchSourceBuilder.query(boolQueryBuilder);

        searchRequest.source(searchSourceBuilder);
        try {
            SearchResponse search = restHighLevelClient.search(searchRequest, RequestOptions.DEFAULT);
            SearchHit[] hits = search.getHits().getHits();
            for (SearchHit hit : hits) {
                String sourceAsString = hit.getSourceAsString();
                TianaoRadar object= JSON.parseObject(sourceAsString,TianaoRadar.class);
                tianaoRadarIdList.add(object.getRadarCode());
            }


        } catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }
}
